package org.asynchronous.jyWebShell.actions;

import org.apache.struts.action.ActionForward;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.asynchronous.jyWebShell.data.Session;
import org.asynchronous.jyWebShell.data.RequestResponse;

public class SessionAction
    extends Action
{
    
    public Session create( SessionForm sForm )
    {
        Session s = new Session( sForm.getName() );
        SessionListAction.setSession( sForm.getName(), s );
        return s;
    }
    
    public ActionForward execute( ActionMapping mapping,
                                  ActionForm form,
                                  HttpServletRequest req,
                                  HttpServletResponse resp )
    {
        SessionForm sForm = (SessionForm)form;
        String sessionName;
        Session pySession = null;
        ActionForward transitionTo = mapping.findForward( "success" );

        sessionName = mapping.getParameter();
        //sForm.setName( name );

        if ( sessionName != null )
        {
            pySession = SessionListAction.getSession( sessionName );
        }
        
        if ( "create".equals( sForm.getDispatch() ) )
        {
            pySession = create( sForm );
            sessionName = sForm.getName();
            transitionTo = new ActionForward( "/session/" + sForm.getName() + ".action", true );
        }
        else if ( "expr".equals( sForm.getDispatch() )
                  || "inlineExpr".equals( sForm.getDispatch() ) )
        {
            String pyExpr;
            RequestResponse newRR;

            pyExpr = sForm.getPythonExpression();
            newRR = pySession.addExpr( pyExpr );
            sForm.setMostRecentResponse( newRR );
            // if it's in-line, return just the result fragment.
            if ( "inlineExpr".equals( sForm.getDispatch() ) )
            {
                transitionTo =  mapping.findForward( "exprResponse" );
            }
            /* else { fall out to normal display } */
        }

        sForm.setName( sessionName );
        sForm.setSession( pySession );
        req.setAttribute( "sessionForm", sForm );
        return transitionTo;
    }
}
