package org.asynchronous.jyWebShell.data;

import java.util.Calendar;

import java.util.ArrayList;

import java.util.List;

import java.util.Date;

import org.python.core.*;
import org.python.util.PythonInterpreter;


public class Session
{
    String _name;
    Date _cTime;
    Date _mTime;
    List /*<RequestResponse>*/ _goRounds;
    PythonInterpreter _pyInterp;

    public Session( String name )
    {
        _name = name;
        _pyInterp = new PythonInterpreter();
        _cTime = new Date( Calendar.getInstance().getTimeInMillis() );
        _mTime = new Date( Calendar.getInstance().getTimeInMillis() );
        _goRounds = new ArrayList();
    }

    public String getName()
    {
        return _name;
    }

    public void setName( String name )
    {
        _name = name;
    }

    public Date getCTime()
    {
        return _cTime;
    }

    public void setCTime( Date ctime )
    {
        _cTime = ctime;
    }

    public Date getMTime()
    {
        return _mTime;
    }

    public void setMTime( Date mtime )
    {
        _mTime = mtime;
    }

    public List getGoRounds()
    {
        return _goRounds;
    }

    public void setGoRounds( List goRounds )
    {
        _goRounds = goRounds;
    }

    public static String pyEvalString( PythonInterpreter pyInter, String expr )
    {
        // ... fixme from thingy ...
        String respToRet = "";
        PyObject res;
        //jtaw.write( ">>> " + expr + "\n" );
        try
        {
            res = pyInter.eval( expr );
            //jtaw.write( res.toString() + "\n" );
            respToRet = res.toString();
        }
        catch ( PyException exec )
        {
            if ( Py.matchException( exec, Py.SyntaxError ) )
            {
                try
                {
                    pyInter.exec( expr );
                }
                catch ( PyException exec2 )
                {
                    //jtaw.write( exec2.toString() );
                    respToRet = exec2.toString();
                    //exec2.printStackTrace( new PrintWriter(jtaw) );
                }
            }
            else
            {
                //jtaw.write( exec.toString() );
                respToRet = exec.toString();
                //exec.printStackTrace( new PrintWriter( jtaw ) );
            }
        }
        return respToRet;
    }

    public RequestResponse addExpr( String expr )
    {
        RequestResponse rr;
        String res;
        res = pyEvalString( _pyInterp, expr );
        rr = new RequestResponse( expr, res );
        _goRounds.add( rr );
        setMTime( new Date(Calendar.getInstance().getTimeInMillis()) );
        return rr;
    }

}
